using Learun.Application.TwoDevelopment.ZZDT_EC;
using Learun.Util;
using Learun.Util.SqlSugar;
using System.Web.Mvc;

namespace Learun.Application.Web.Areas.ZZDT_EC.Controllers
{
    /// <summary>
    /// 版 本 PIT-ADMS V7.0.3 敏捷开发框架
    /// Copyright (c) 2013-2018 Hexagon PPM
    /// 创 建：超级管理员
    /// 日 期：2023-02-23 11:30
    /// 描 述：项目设置
    /// </summary>
    public class ec_ProjectSettingsController : MvcControllerBase
    {
        private ec_projectSettingsBLL ec_projectSettingsIBLL = new ec_projectSettingsBLL();

        #region 视图功能
        /// <summary>
        /// 主页面
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        public ActionResult Index()
        {
            return View();
        }
        /// <summary>
        /// 表单页
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        public ActionResult Form()
        {
            return View();
        }
        #endregion

        #region 获取数据
        /// <summary>
        /// 获取列表数据
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetList(string queryJson)
        {
            var data = ec_projectSettingsIBLL.GetList(queryJson);
            return Success(data);
        }
        /// <summary>
        /// 获取页面显示列表数据
        /// <summary>
        /// <param name="queryJson">查询参数</param>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetPageList(string pagination, string queryJson)
        {
            Pagination paginationobj = pagination.ToObject<Pagination>();
            paginationobj.sidx = "OrderID ";
            paginationobj.sord = "ASC";
            var queryParam = queryJson.ToJObject();
            string ProjectId = queryParam["ProjectId"]?.ToString();
            string SettingName = queryParam["SettingName"]?.ToString();
            var tableName = ProjectSugar.TableName<ec_projectSettingsEntity>(ProjectId);
            int records = 0;
            var list = SqlSugarHelper.Db.Queryable<ec_projectSettingsEntity>().AS(tableName)
                .WhereIF(!string.IsNullOrEmpty(SettingName), a => a.SettingName.Contains(SettingName))
                .ToPageList(paginationobj.page, paginationobj.rows, ref records);
            paginationobj.records = records;
            var jsonData = new
            {
                rows = list,
                total = paginationobj.total,
                page = paginationobj.page,
                records = paginationobj.records
            };
            return Success(jsonData);
        }
        /// <summary>
        /// 获取表单数据
        /// <param name="keyValue">主键</param>
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetFormData(string keyValue, string ProjectId)
        {
            var tableName = ProjectSugar.TableName<ec_projectSettingsEntity>(ProjectId);
            var jsonData = new
            {
                ec_ProjectSettings = SqlSugarHelper.Db.Queryable<ec_projectSettingsEntity>().AS(tableName).First(x => x.SettingID == keyValue)
            };
            return Success(jsonData);
        }
        #endregion
        #region 提交数据
        /// <summary>
        /// 删除实体数据
        /// <param name="keyValue">主键</param>
        /// <summary>
        /// <returns></returns>
        [HttpPost]
        [AjaxOnly]
        public ActionResult DeleteForm(string keyValue, string ProjectId)
        {
            ec_projectSettingsIBLL.DeleteEntity(keyValue, ProjectId);
            return Success("删除成功！");
        }
        /// <summary>
        /// 名字不能改。不然设置项目相当于删除了
        /// <param name="keyValue">主键</param>
        /// <summary>
        /// <returns></returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOnly]
        public ActionResult SaveForm(string keyValue, string strEntity, string ProjectId)
        {
            ec_projectSettingsEntity entity = strEntity.ToObject<ec_projectSettingsEntity>();
            entity.SettingID = keyValue;
            ec_projectSettingsIBLL.SaveEntity(entity, ProjectId);
            return Success("保存成功！");
        }
        #endregion
    }
}